#include "minialsa.h"

#define MAX_SAMPLES 8192

static int unsolved(const char* name)
{
    printf("%s Unresolved ....\r\n", name);
    return 0;
}

#define DEFINE_UNSOLVED_FUNCTION(f) int f(int x){return unsolved(#f);}

DEFINE_UNSOLVED_FUNCTION(snd_strerror)
DEFINE_UNSOLVED_FUNCTION(snd_pcm_prepare)
DEFINE_UNSOLVED_FUNCTION(snd_pcm_start)


//Dummy
DEFINE_UNSOLVED_FUNCTION(snd_pcm_hw_params_set_format)
DEFINE_UNSOLVED_FUNCTION(snd_pcm_hw_params_set_channels)
DEFINE_UNSOLVED_FUNCTION(snd_pcm_hw_params_set_rate_near)

int snd_pcm_open (snd_pcm_t** pcm, const char* dev, int flags, int sync)
{
    snd_pcm_t* snd = malloc(sizeof(snd_pcm_t));
    *pcm = snd;
    snd->fd = fopen("C:\\output.pcm", "wb");
    snd->state = SND_PCM_STATE_SUSPENDED;
    snd->frames = MAX_SAMPLES;
    snd->samples = malloc(MAX_SAMPLES * 4);
    snd->writer = 0;
    return 0;
}
int snd_pcm_hw_params_set_buffer_size_near (snd_pcm_t* pcm, void* hw_params, int* uframes)
{
    pcm->state = SND_PCM_STATE_SUSPENDED;
    pcm->frames = *uframes;
    pcm->samples = realloc(pcm->samples, *uframes * 4);
    pcm->writer = 0;
    return 0;
}

int snd_pcm_close(snd_pcm_t* pcm)
{
    fclose(pcm->fd);
    free(pcm->samples);
    free(pcm);
    return 0;
}

int snd_pcm_poll_descriptors_count(snd_pcm_t* pcm)
{
    return pcm->fd ? 1 :0;
}

int snd_pcm_state(snd_pcm_t* pcm)
{
    return pcm->state;
}

long snd_pcm_avail_update(snd_pcm_t* pcm)
{
    long ret = pcm->frames - pcm->writer;
    if (ret <= 0 )
        ret = -EPIPE;
    pcm->state = SND_PCM_STATE_RUNNING;
    return ret;
}

int snd_pcm_writei(snd_pcm_t* pcm, void* data, int written)
{
//    pcm->writer += written;
    fwrite(data, written, 4, pcm->fd);
    fflush(pcm->fd);
    return written;
}

int snd_pcm_poll_descriptors(snd_pcm_t* pcm, struct pollfd* polls, int n)
{
	polls->fd = pcm->fd;
	polls->events = 0;
    return snd_pcm_poll_descriptors_count(pcm);
}

